#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, q;
    cin >> n >> q;
    long long int tr = 0;
    vector<int> d(n);    // dan
    vector<int> p(n);    // kolicina
    vector<int> k(q);    // pitanja
    vector<int> z(1, 0); // izlaz
    for (int i = 0; i < n; i++)
    {
        cin >> d[i];
        cin >> p[i];
    }
    for (int i = 0; i < q; i++)
        cin >> k[i];
    int di = 0, i = 1;
    while ((tr != 0) || (di != n))
    {
        if (d[di] == i)
            tr += p[di++];
        if (tr != 0)
        {
            z.push_back(z[i - 1] + 1);
            tr--;
        }
        else
            z.push_back(z[i - 1]);
        i++;
    }
    for (int i = 0; i < q; i++)
        cout << z[k[i]];
}